from javax.imageio import ImageIO
from java.io import File
from nodebox.graphics import Point,Path,Color
from math import sqrt

def luma(foto, points):

    lvals = []
    f = File(foto)
    bi = ImageIO.read(f)
    raster = bi.raster
    rType = raster.numDataElements
    w = raster.width
    h = raster.height

    for p in points:
        x = int(p.x)
        x = min(x,w-1)
        x = max(x,0)
        y = int(p.y)
        y = min(y,h-1)
        y = max(y,0)
        if rType==1:
            c = bi.raster.getPixel(x,y,[0.0])
            lvals.append(c[0])
        elif rType==3:
            c = bi.raster.getPixel(x,y,[0.0,0.0,0.0])
            lvals.append(c[0]*.3 + c[1]*.59 + c[2]*.11)
        else:
            c = bi.raster.getPixel(x,y,[0.0,0.0,0.0,0.0])
            lvals.append(c[0]*.3 + c[1]*.59 + c[2]*.11)
    return lvals


def bounds(foto):

    f = File(foto)
    bi = ImageIO.read(f)
    w = bi.getWidth()
    h = bi.getHeight()
    p = Path()
    p.moveto(-1*w/2,-1*h/2)
    p.lineto(w/2,-1*h/2)
    p.lineto(w/2,h/2)
    p.lineto(-1*w/2,h/2)
    p.close()
    p.fill = Color(.75,.75,.75,.75)
    p.stroke = Color.BLACK
    p.strokeWidth = 0.0
    return p

def image(foto,sample,alpha):

    if sample > 9999:
        return 0
    else:
        f = File(foto)
        bi = ImageIO.read(f)
        raster = bi.raster
        rType = raster.numDataElements
        w = raster.width
        h = raster.height
        sam = sample
        all = []
        for i in [int(x * sam) for x in range(0, int(h/sam))]:
            for j in [int(x * sam) for x in range(0, int(w/sam))]:
                if rType==1:
                    c = bi.raster.getPixel(j,i,[0.0])
                    all.append(Color(c[0]/255,c[0]/255,c[0]/255,alpha))
                elif rType==3:
                    c = bi.raster.getPixel(j,i,[0.0,0.0,0.0])
                    all.append(Color(c[0]/255,c[1]/255,c[2]/255,alpha))
                else:
                    c = bi.raster.getPixel(j,i,[0.0,0.0,0.0,0.0])
                    all.append(Color(c[0]/255,c[1]/255,c[2]/255,(c[3]*alpha)/255))
        return all

def image_path(foto, points):

    all = []
    alpha = 1
    f = File(foto)
    bi = ImageIO.read(f)
    raster = bi.raster
    rType = raster.numDataElements
    w = raster.width
    h = raster.height

    for p in points:
        x = float(p.x)
        x = min(x,w-1)
        x = max(x,0)
        y = float(p.y)
        y = min(y,h-1)
        y = max(y,0)

        if rType==1:
            c = bi.raster.getPixel(x,y,[0.0])
            all.append(Color(c[0]/255,c[0]/255,c[0]/255,alpha))
        elif rType==3:
            c = bi.raster.getPixel(x,y,[0.0,0.0,0.0])
            all.append(Color(c[0]/255,c[1]/255,c[2]/255,alpha))
        else:
            c = bi.raster.getPixel(x,y,[0.0,0.0,0.0,0.0])
            all.append(Color(c[0]/255,c[1]/255,c[2]/255,(c[3]*alpha)/255))

    return all
            
